JavaScript/jQuery SelectBox - Handle the Value Change Event
By default, the value of the SelectBox is changed when the change event is raised. If you need the value to be changed on another event, set the valueChangeEvent property.
- const selectBoxData = [
- { id: 1, country: "Afghanistan" },
- { id: 2, country: "Albania" },
- // ...
- ];
- $(function() {
- $("#selectBoxContainer").dxSelectBox({
- dataSource: selectBoxData,
- valueExpr: 'id',
- displayExpr: 'country',
- valueChangeEvent: 'keyup'
- });
- });
To process a new SelectBox value, you need to handle the value change event. If the handling function is not going to be changed during the lifetime of the UI component, assign it to the onValueChanged property when you configure the UI component.
- $(function() {
- $("#selectBoxContainer").dxSelectBox({
- onValueChanged: function (e) {
- const previousValue = e.previousValue;
- const newValue = e.value;
- // Event handling commands go here
- }
- });
- });
If you are going to change event handlers at runtime, or if you need to attach several handlers to the value change event, subscribe to this event using the on(eventName, eventHandler) method. This approach is more typical of jQuery.
- const valueChangedHandler1 = function (e) {
- const previousValue = e.previousValue;
- const newValue = e.value;
- // First handler of the "valueChanged" event
- };
- const valueChangedHandler2 = function (e) {
- const previousValue = e.previousValue;
- const newValue = e.value;
- // Second handler of the "valueChanged" event
- };
- $("#selectBoxContainer").dxSelectBox("instance")
- .on("valueChanged", valueChangedHandler1)
- .on("valueChanged", valueChangedHandler2);
See Also
If you have technical questions, please create a support ticket in the DevExpress Support Center.

Vue SelectBox - Handle the Value Change Event

By default, the value of the SelectBox is changed when the change event is raised. If you need the value to be changed on another event, set the valueChangeEvent property.

App.vue
  • <template>
  • <DxSelectBox ...
  • :data-source="selectBoxData"
  • display-expr="country"
  • value-expr="id"
  • value-change-event="keyup"
  • />
  • </template>
  •  
  • <script>
  • import 'devextreme/dist/css/dx.common.css';
  • import 'devextreme/dist/css/dx.light.css';
  •  
  • import { DxSelectBox } from 'devextreme-vue/select-box';
  •  
  • export default {
  • components: {
  • DxSelectBox
  • },
  • data() {
  • const selectBoxData = [
  • { id: 1, country: "Afghanistan" },
  • { id: 2, country: "Albania" },
  • // ...
  • ];
  • return {
  • selectBoxData
  • }
  • }
  • }
  • </script>

To process a new SelectBox value, you need to handle the value change event. If the handling function is not going to be changed during the lifetime of the UI component, assign it to the onValueChanged property when you configure the UI component.

App.vue
  • <template>
  • <DxSelectBox ...
  • @value-changed="valueChanged"
  • />
  • </template>
  •  
  • <script>
  • import 'devextreme/dist/css/dx.common.css';
  • import 'devextreme/dist/css/dx.light.css';
  •  
  • import { DxSelectBox } from 'devextreme-vue/select-box';
  •  
  • export default {
  • components: {
  • DxSelectBox
  • },
  • methods: {
  • valueChanged(e) {
  • const previousValue = e.previousValue;
  • const newValue = e.value;
  • // Event handling commands go here
  • }
  • }
  • }
  • </script>

If you are going to change event handlers at runtime, or if you need to attach several handlers to the value change event, subscribe to this event using the on(eventName, eventHandler) method. This approach is more typical of jQuery.

JavaScript
  • const valueChangedHandler1 = function (e) {
  • const previousValue = e.previousValue;
  • const newValue = e.value;
  • // First handler of the "valueChanged" event
  • };
  •  
  • const valueChangedHandler2 = function (e) {
  • const previousValue = e.previousValue;
  • const newValue = e.value;
  • // Second handler of the "valueChanged" event
  • };
  •  
  • $("#selectBoxContainer").dxSelectBox("instance")
  • .on("valueChanged", valueChangedHandler1)
  • .on("valueChanged", valueChangedHandler2);
See Also

Angular SelectBox - Handle the Value Change Event

By default, the value of the SelectBox is changed when the change event is raised. If you need the value to be changed on another event, set the valueChangeEvent property.

HTML
TypeScript
  • <dx-select-box
  • [dataSource]="selectBoxData"
  • valueExpr="id"
  • displayExpr="country"
  • valueChangeEvent="keyup">
  • </dx-select-box>
  • import { DxSelectBoxModule } from "devextreme-angular";
  • // ...
  • export class AppComponent {
  • selectBoxData = [
  • { id: 1, country: "Afghanistan" },
  • { id: 2, country: "Albania" },
  • // ...
  • ];
  • }
  • @NgModule({
  • imports: [
  • // ...
  • DxSelectBoxModule
  • ],
  • // ...
  • })

To process a new SelectBox value, you need to handle the value change event. If the handling function is not going to be changed during the lifetime of the UI component, assign it to the onValueChanged property when you configure the UI component.

HTML
TypeScript
  • <dx-select-box ...
  • (onValueChanged)="onValueChanged($event)">
  • </dx-select-box>
  • import { DxSelectBoxModule } from "devextreme-angular";
  • // ...
  • export class AppComponent {
  • onValueChanged (e) {
  • const previousValue = e.previousValue;
  • const newValue = e.value;
  • // Event handling commands go here
  • }
  • }
  • @NgModule({
  • imports: [
  • // ...
  • DxSelectBoxModule
  • ],
  • // ...
  • })

If you are going to change event handlers at runtime, or if you need to attach several handlers to the value change event, subscribe to this event using the on(eventName, eventHandler) method. This approach is more typical of jQuery.

JavaScript
  • const valueChangedHandler1 = function (e) {
  • const previousValue = e.previousValue;
  • const newValue = e.value;
  • // First handler of the "valueChanged" event
  • };
  •  
  • const valueChangedHandler2 = function (e) {
  • const previousValue = e.previousValue;
  • const newValue = e.value;
  • // Second handler of the "valueChanged" event
  • };
  •  
  • $("#selectBoxContainer").dxSelectBox("instance")
  • .on("valueChanged", valueChangedHandler1)
  • .on("valueChanged", valueChangedHandler2);
See Also

React SelectBox - Handle the Value Change Event

By default, the value of the SelectBox is changed when the change event is raised. If you need the value to be changed on another event, set the valueChangeEvent property.

App.js
  • import React from 'react';
  • import 'devextreme/dist/css/dx.common.css';
  • import 'devextreme/dist/css/dx.light.css';
  •  
  • import SelectBox from 'devextreme-react/select-box';
  •  
  • const selectBoxData = [
  • { id: 1, country: "Afghanistan" },
  • { id: 2, country: "Albania" },
  • // ...
  • ];
  •  
  • class App extends React.Component {
  • render() {
  • return (
  • <SelectBox ...
  • dataSource={selectBoxData}
  • displayExpr="country"
  • valueExpr="id"
  • valueChangeEvent="keyup"
  • />
  • );
  • }
  • }
  • export default App;

To process a new SelectBox value, you need to handle the value change event. If the handling function is not going to be changed during the lifetime of the UI component, assign it to the onValueChanged property when you configure the UI component.

App.js
  • import React from 'react';
  • import 'devextreme/dist/css/dx.common.css';
  • import 'devextreme/dist/css/dx.light.css';
  •  
  • import SelectBox from 'devextreme-react/select-box';
  •  
  • class App extends React.Component {
  • constructor(props) {
  • super(props);
  • this.valueChanged = this.valueChanged.bind(this);
  • }
  • valueChanged(e) {
  • const previousValue = e.previousValue;
  • const newValue = e.value;
  • // Event handling commands go here
  • }
  • render() {
  • return (
  • <SelectBox ...
  • onValueChanged={this.valueChanged}
  • />
  • );
  • }
  • }
  • export default App;

If you are going to change event handlers at runtime, or if you need to attach several handlers to the value change event, subscribe to this event using the on(eventName, eventHandler) method. This approach is more typical of jQuery.

JavaScript
  • const valueChangedHandler1 = function (e) {
  • const previousValue = e.previousValue;
  • const newValue = e.value;
  • // First handler of the "valueChanged" event
  • };
  •  
  • const valueChangedHandler2 = function (e) {
  • const previousValue = e.previousValue;
  • const newValue = e.value;
  • // Second handler of the "valueChanged" event
  • };
  •  
  • $("#selectBoxContainer").dxSelectBox("instance")
  • .on("valueChanged", valueChangedHandler1)
  • .on("valueChanged", valueChangedHandler2);
See Also